	*-----------------------------------------------------------------------
	* 1.1 Program Definition
	*-----------------------------------------------------------------------

		* Program for saving all relevant data/coefficients from the regression
		* Can only be run after a regression

		*-------------------------------------------------------------------
		* 1.1a For treatment variables
		*-------------------------------------------------------------------

			cap prog drop save_coeff //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff

			args name_var
				global `name_var'm0 :  di %4.3f `r(mean)'
				global `name_var's0 :  di %4.3f `r(sd)'
				local mean 	= `r(mean)'
				local sd 	= `r(sd)'

			global `name_var'1 :  di %4.3f _b[t1_2]
			global `name_var'2 :  di %4.3f _b[t2_2]
			global `name_var'1sd :  di %4.3f _se[t1_2]
			global `name_var'2sd :  di %4.3f _se[t2_2]

			global `name_var's1 :  di %4.2f _b[t1_2] / `sd'
				global `name_var'imp1 =   _b[t1_2] /`mean'*100
			if ${`name_var'imp1} >= 10 {
				global `name_var'imp1 :  di %2.0f ${`name_var'imp1}
			}
			if ${`name_var'imp1} < 10 {
				global `name_var'imp1 :  di %1.0f ${`name_var'imp1}
			}

			global `name_var's2 :  di %4.2f _b[t2_2] / `sd'
				global `name_var'imp2 =   _b[t2_2] /`mean'*100
			if ${`name_var'imp2} >= 10 {
				global `name_var'imp2 :  di %2.0f ${`name_var'imp2}
			}
			if ${`name_var'imp2} < 10 {
				global `name_var'imp2 :  di %1.0f ${`name_var'imp2}
			}

			*Other locals
			global R_`name_var' :  di %4.3f e(r2)
			global N_`name_var' = e(N)

			*Pvalues
			global `name_var'1p :  di %4.3f (2 * ttail(e(df_r), abs(_b[t1_2]/_se[t1_2])))
			global `name_var'2p :  di %4.3f (2 * ttail(e(df_r), abs(_b[t2_2]/_se[t2_2])))

			*Test of equality
			test t1_2 = t2_2
			global `name_var'test :  di %4.3f r(p)

				end //

		*-------------------------------------------------------------------
		* 1.1b For treatment variables pooled
		*-------------------------------------------------------------------

			cap prog drop save_coeff_t //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff_t

			args name_var
				global `name_var'm0 :  di %4.3f `r(mean)'
				global `name_var's0 :  di %4.3f `r(sd)'
				local mean 	= `r(mean)'
				local sd 	= `r(sd)'

			global `name_var'1 :  di %4.3f _b[t]
			global `name_var'1sd :  di %4.3f _se[t]

			global `name_var's1 :  di %4.2f _b[t] / `sd'
				global `name_var'imp1 =   _b[t] /`mean'*100
			if ${`name_var'imp1} >= 10 {
				global `name_var'imp1 :  di %2.0f ${`name_var'imp1}
			}
			if ${`name_var'imp1} < 10 {
				global `name_var'imp1 :  di %1.0f ${`name_var'imp1}
			}
			
			*Other locals
			global R_`name_var' :  di %4.3f e(r2)
			global N_`name_var' = e(N)

			*Pvalues
			global `name_var'1p :  di %4.3f (2 * ttail(e(df_r), abs(_b[t]/_se[t])))

				end //
				
				
				
				
			cap prog drop save_coeff_graph //Just saving values to enter them in a variable to then have a graph

				prog def save_coeff_graph

			args name_var
	
			*Saving for a graph too if needed 
			global coeff_`name_var' = r(table)[1,1]
			global ll_`name_var'    = r(table)[5,1]
			global ul_`name_var'    = r(table)[6,1]
			
				end //				

		*-------------------------------------------------------------------
		* 1.1c For non treatment variables
		*-------------------------------------------------------------------

			cap prog drop save_coeff_indvar //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff_indvar
			args name_var indep_var

			global `name_var'3 :  di %4.3f _b[`indep_var']
			global `name_var'3sd :  di %4.3f _se[`indep_var']
			global `name_var'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var']/_se[`indep_var'])))

			end //

		*-------------------------------------------------------------------
		* 1.1d For interaction terms with treatment
		*-------------------------------------------------------------------

			cap prog drop save_coeff_interaction //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff_interaction
			args name_var name_var_t indep_var indep_var_t 
			
				global `name_var'm0 :  di %4.3f `r(mean)'
				global `name_var's0 :  di %4.3f `r(sd)'
				local mean 	= `r(mean)'
				local sd 	= `r(sd)'
			global `name_var'1 :  di %4.3f _b[t]
			global `name_var'1sd :  di %4.3f _se[t]

			global `name_var's1 :  di %4.2f _b[t] / `sd'
				global `name_var'imp1 =   _b[t] /`mean'*100
			if ${`name_var'imp1} >= 10 {
				global `name_var'imp1 :  di %2.0f ${`name_var'imp1}
			}
			if ${`name_var'imp1} < 10 {
				global `name_var'imp1 :  di %1.0f ${`name_var'imp1}
			}			

			global `name_var'3 :  di %4.3f 		_b[`indep_var']
			global `name_var'3sd :  di %4.3f 	_se[`indep_var']
			global `name_var'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var']/_se[`indep_var'])))

			global `name_var_t'3 :  di %4.3f	 _b[`indep_var_t']
			global `name_var_t'3sd :  di %4.3f 	 _se[`indep_var_t']
			global `name_var_t'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var_t']/_se[`indep_var_t'])))
					

			*Test of equality
			test t + `indep_var_t' = 0
			global `name_var'test :  di %4.3f r(p)

			end //
			
		*-------------------------------------------------------------------
		* 1.1d2 For interaction terms with treatment - expanded decimals
		*-------------------------------------------------------------------

			cap prog drop save_coeff_interaction_dec //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff_interaction_dec
			args name_var name_var_t indep_var indep_var_t 
			
				global `name_var'm0 :  di %4.3f `r(mean)'
				global `name_var's0 :  di %4.3f `r(sd)'
				local mean 	= `r(mean)'
				local sd 	= `r(sd)'
			global `name_var'1 :  di %20.3f _b[t]
			global `name_var'1sd :  di %4.3f _se[t]

			global `name_var's1 :  di %4.2f _b[t] / `sd'
				global `name_var'imp1 =   _b[t] /`mean'*100
			if ${`name_var'imp1} >= 10 {
				global `name_var'imp1 :  di %2.0f ${`name_var'imp1}
			}
			if ${`name_var'imp1} < 10 {
				global `name_var'imp1 :  di %1.0f ${`name_var'imp1}
			}			

			global `name_var'3 :  di %20.3f 		_b[`indep_var']
			global `name_var'3sd :  di %4.3f 	_se[`indep_var']
			global `name_var'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var']/_se[`indep_var'])))

			global `name_var_t'3 :  di %20.3f	 _b[`indep_var_t']
			global `name_var_t'3sd :  di %4.3f 	 _se[`indep_var_t']
			global `name_var_t'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var_t']/_se[`indep_var_t'])))
					

			*Test of equality
			test t + `indep_var_t' = 0
			global `name_var'test :  di %4.3f r(p)

			end //			

		*-------------------------------------------------------------------
		* 1.1e For interaction terms with treatment
		*-------------------------------------------------------------------

			cap prog drop save_coeff_interaction_quadra //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff_interaction_quadra
			args name_var name_var_t indep_var indep_var_t

			global `name_var'3 :  di %4.3f _b[`indep_var']
			global `name_var'3sd :  di %4.3f _se[`indep_var']
			global `name_var'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var']/_se[`indep_var'])))

			global `name_var'23 :  di %4.3f _b[`indep_var'2]
			global `name_var'23sd :  di %4.3f _se[`indep_var'2]
			global `name_var'23p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var'2]/_se[`indep_var'2])))

			global `name_var_t'3 :  di %4.3f _b[`indep_var_t']
			global `name_var_t'3sd :  di %4.3f _se[`indep_var_t']
			global `name_var_t'3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var_t']/_se[`indep_var_t'])))

			global `name_var'2_t3 :  di %4.3f _b[`indep_var'2_t]
			global `name_var'2_t3sd :  di %4.3f _se[`indep_var'2_t]
			global `name_var'2_t3p  :  di %4.3f (2 * ttail(e(df_r), abs(_b[`indep_var'2_t]/_se[`indep_var'2_t])))

			*Test of equality
			test t + `indep_var_t' + `indep_var'2_t = 0
			global `name_var'test :  di %4.3f r(p)

			end //

		*-------------------------------------------------------------------
		* 1.1f Adding the stars for the coefficients
		*-------------------------------------------------------------------

			cap prog drop star //clearing any program that might exist under that name. Always start with that line

				prog def star
			args coeff

			foreach i in ${`coeff'} {

					if  ${`i'p} <= 0.1 {
					global `i' = "${`i'}" + "*"

						if ${`i'p} <= 0.05 {
						global `i' = "${`i'}" + "*"

							if ${`i'p} <= 0.01 {
							global `i' = "${`i'}" + "*"

						}
					}
				}
			}

			end //	
			

		*-------------------------------------------------------------------
		* 1.1d Computes the main three when there is an interaction with treatment
		*-------------------------------------------------------------------

			cap prog drop save_coeff_interaction_all //clearing any program that might exist under that name. Always start with that line

				prog def save_coeff_interaction_all
			args dep_var treatment name_treatment indep_var name_indep_var indep_var_t name_indep_var_t weight  // If no weights, just finish with " "
			
		
		*First getting the control mean for each group
		forvalues i=0/1 {
			sum `dep_var' `weight' if `treatment' == 0 & e(sample)==1 & `indep_var' == `i'
				global `name_treatment'm`i' :  di %4.3f `r(mean)'
				global `name_treatment's`i' :  di %4.3f `r(sd)'
				local mean`i' 	= abs(`r(mean)')
				local sd`i' 	= `r(sd)'
		}	
		
		*Coefficients
		foreach var in treatment indep_var indep_var_t {
			global `name_`var''t   :  di %10.3fc _b[``var'']
			global `name_`var''tse :  di %10.3fc _se[``var'']	
			global `name_`var''p   :  di %4.3f (2 * ttail(e(df_r), abs(_b[``var'']/_se[``var''])))
		}

		*Impacts
		global `name_treatment'impsd0 :  di %4.2f _b[`treatment'] / `sd0'
				global `name_treatment'imp0 =   _b[`treatment'] /`mean0'*100
			if ${`name_treatment'imp0} >= 10 {
				global `name_treatment'imp0 :  di %2.0f ${`name_treatment'imp0}
			}
			if ${`name_treatment'imp0} < 10 {
				global `name_treatment'imp0 :  di %1.0f ${`name_treatment'imp0}
			}
			
		global `name_treatment'impsd1 :  di %4.2f (_b[`treatment']+ _b[`indep_var_t']) / `sd1'
				global `name_treatment'imp1 =     (_b[`treatment']+ _b[`indep_var_t']) /`mean1'*100
			if ${`name_treatment'imp1} >= 10 {
				global `name_treatment'imp1 :  di %2.0f ${`name_treatment'imp1}
			}
			if ${`name_treatment'imp1} < 10 {
				global `name_treatment'imp1 :  di %1.0f ${`name_treatment'imp1}
			}

					
			global `name_treatment'R :  di %10.3f e(r2)
			global `name_treatment'N 	= e(N)
			
			*Test of equality
			test `treatment' + `indep_var_t' = 0
			global `name_treatment'test :  di %4.3f r(p)
					
*Adding the star and Putting all numbers in string to have them in math mode in Latex
foreach var in treatment indep_var indep_var_t {		
			global `name_`var''t = "$" + "${`name_`var''t}" + "$"
		if  ${`name_`var''p} <= 0.1 {
		global `name_`var''t = "${`name_`var''t}" + "*"		
			if ${`name_`var''p} <= 0.05 {
			global `name_`var''t = "${`name_`var''t}" + "*"
				if ${`name_`var''p} <= 0.01 {
				global `name_`var''t = "${`name_`var''t}" + "*"
				
			}				
		}
	}
global `name_`var''tse 	= "$" + "${`name_`var''tse}" 	+ "$"
global `name_`var''p 	= "$" + "${`name_`var''p}" 		+ "$"	
}	

*Putting all numbers in string to have them in math mode in Latex
forvalues i =0/1 {
	global `name_treatment'm`i' 	= "$" + "${`name_treatment'm`i'}" 	+ "$"
	global `name_treatment's`i' 	= "$" + "${`name_treatment's`i'}" 	+ "$"

	global `name_treatment'impsd`i' = "$" + "${`name_treatment'impsd`i'}" 	+ "$"
	global `name_treatment'imp`i'   = "$" + "${`name_treatment'imp`i'}" 	+ "$"
}
global `name_treatment'R 	= "$" + "${`name_treatment'R}" 		+ "$"
			end //
			
		*-------------------------------------------------------------------
		* 1.1g Similar to the previous programs, used for intermediate outcome, should be merged with the others at some point
		*-------------------------------------------------------------------
		
cap prog drop coeff_treat //clearing any program that might exist under that name. Always start with that line

	prog def coeff_treat

args name_coeff name_var

local mean = `r(mean)'
if `mean' >= 0 {
	global meanpos = `mean'
}
if `mean' < 0 {
	global meanpos = -`mean'
}

local sd = `r(sd)'
	global `name_coeff'm0 :  di %10.3fc `r(mean)'


	global `name_coeff's0 :  di %10.3fc `r(sd)'


global `name_coeff't :  di %10.3fc _b[`name_var']


global `name_coeff'tse :  di %10.3fc _se[`name_var']


*Impact in percentage:

 	global `name_coeff'imp1_n =   _b[`name_var'] /$meanpos * 100

if ${`name_coeff'imp1_n} >= 10 {
	global `name_coeff'imp1_n :  di %2.0f ${`name_coeff'imp1_n}	
}
if ${`name_coeff'imp1_n} < 10 {
	global `name_coeff'imp1_n :  di %1.0f ${`name_coeff'imp1_n}	
}

*Impact in standard deviation: 
global `name_coeff'imp2_n = _b[`name_var']/`sd'	
global `name_coeff'imp2_n : di %10.3fc ${`name_coeff'imp2_n}



*Other locals
global `name_coeff'R :  di %10.3f e(r2)
global `name_coeff'N 	= e(N)


*Pvalues
global `name_coeff'p :  di %10.3f (2 * ttail(e(df_r), abs(_b[`name_var']/_se[`name_var'])))


global `name_coeff't = "$" + "${`name_coeff't}" + "$"
*Adding the star
	*disp "`i'"
		if  ${`name_coeff'p} <= 0.1 {
		global `name_coeff't = "${`name_coeff't}" + "*"
			
			if ${`name_coeff'p} <= 0.05 {
			global `name_coeff't = "${`name_coeff't}" + "*"

				if ${`name_coeff'p} <= 0.01 {
				global `name_coeff't = "${`name_coeff't}" + "*"
				
			}				
		}
	}
	

*Putting all numbers in string to have them in math mode in Latex
global `name_coeff'm0 	= "$" + "${`name_coeff'm0}" 	+ "$"
global `name_coeff's0 	= "$" + "${`name_coeff's0}" 	+ "$"
global `name_coeff'tse 	= "$" + "${`name_coeff'tse}" 	+ "$"
global `name_coeff'p 	= "$" + "${`name_coeff'p}" 		+ "$"
global `name_coeff'N 	= "$" + "${`name_coeff'N}" 		+ "$"
global `name_coeff'N_hf = "$" + "${`name_coeff'N_hf}" 	+ "$"
global `name_coeff'R 	= "$" + "${`name_coeff'R}" 		+ "$"
global `name_coeff'imp1 = "$" + "${`name_coeff'imp1_n}" 	+ "$"
global `name_coeff'imp2 = "$" + "${`name_coeff'imp2_n}" 	+ "$"
	end //

			
		*-------------------------------------------------------------------
		* 1.1h Getting statistics per public / private
		*-------------------------------------------------------------------
		*To use after a "sum" command and a reg command, for instance, "sum `x' if t==0 & $sample==1 & private==0". Gives stat and impact

					cap prog drop stat_public //clearing any program that might exist under that name. Always start with that line

				prog def stat_public
			args name_var 

						global `name_var'm0pu :  di %4.3f `r(mean)'
						global `name_var's0pu:  di %4.3f `r(sd)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1pu :  di %4.2f _b[t] / `sd'
							global `name_var'imp1pu =   _b[t] /`mean'*100
						if ${`name_var'imp1pu} >= 10 {
							global `name_var'imp1pu :  di %2.0f ${`name_var'imp1pu}
						}
						if ${`name_var'imp1pu} < 10 {
							global `name_var'imp1pu :  di %1.0f ${`name_var'imp1pu}
						}

			end //
		
			cap prog drop stat_private //clearing any program that might exist under that name. Always start with that line

				prog def stat_private
			args name_var 

						global `name_var'm0pr :  di %4.3f `r(mean)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1pr :  di %4.2f (_b[t] + _b[private_t]) / `sd'
							global `name_var'imp1pr =   (_b[t] + _b[private_t]) /`mean'*100
						if ${`name_var'imp1pr} >= 10 {
							global `name_var'imp1pr :  di %2.0f ${`name_var'imp1pr}
						}
						if ${`name_var'imp1pr} < 10 {
							global `name_var'imp1pr :  di %1.0f ${`name_var'imp1pr}
						}

			end //
			
		*-------------------------------------------------------------------
		* 1.1h Getting statistics per licensed / unlicensed at endline
		*-------------------------------------------------------------------
		
					cap prog drop stat_lic //clearing any program that might exist under that name. Always start with that line

				prog def stat_lic
			args name_var 

						global `name_var'm0lic :  di %4.3f `r(mean)'
						global `name_var's0lic:  di %4.3f `r(sd)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1lic :  di %4.2f _b[t] / `sd'
							global `name_var'imp1lic =   _b[t] /`mean'*100
						if ${`name_var'imp1lic} >= 10 {
							global `name_var'imp1lic :  di %2.0f ${`name_var'imp1lic}
						}
						if ${`name_var'imp1lic} < 10 {
							global `name_var'imp1lic :  di %1.0f ${`name_var'imp1lic}
						}

			end //
		
			cap prog drop stat_unl //clearing any program that might exist under that name. Always start with that line

				prog def stat_unl
			args name_var 

						global `name_var'm0unl :  di %4.3f `r(mean)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1unl :  di %4.2f (_b[t] + _b[unlicensed_s2_t]) / `sd'
							global `name_var'imp1unl =   (_b[t] + _b[unlicensed_s2_t]) /`mean'*100
						if ${`name_var'imp1unl} >= 10 {
							global `name_var'imp1unl :  di %2.0f ${`name_var'imp1unl}
						}
						if ${`name_var'imp1unl} < 10 {
							global `name_var'imp1unl :  di %1.0f ${`name_var'imp1unl}
						}

			end //			
			
			
		*-------------------------------------------------------------------
		* 1.1h Getting statistics per licensed / unlicensed at randomization
		*-------------------------------------------------------------------
		
					cap prog drop stat_lic_s0 //clearing any program that might exist under that name. Always start with that line

				prog def stat_lic_s0
			args name_var 

						global `name_var'm0lic :  di %4.3f `r(mean)'
						global `name_var's0lic:  di %4.3f `r(sd)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1lic :  di %4.2f _b[t] / `sd'
							global `name_var'imp1lic =   _b[t] /`mean'*100
						if ${`name_var'imp1lic} >= 10 {
							global `name_var'imp1lic :  di %2.0f ${`name_var'imp1lic}
						}
						if ${`name_var'imp1lic} < 10 {
							global `name_var'imp1lic :  di %1.0f ${`name_var'imp1lic}
						}

			end //
		
			cap prog drop stat_unl_s0 //clearing any program that might exist under that name. Always start with that line

				prog def stat_unl_s0
			args name_var 

						global `name_var'm0unl :  di %4.3f `r(mean)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1unl :  di %4.2f (_b[t] + _b[unlicensed_s0_t]) / `sd'
							global `name_var'imp1unl =   (_b[t] + _b[unlicensed_s0_t]) /`mean'*100
						if ${`name_var'imp1unl} >= 10 {
							global `name_var'imp1unl :  di %2.0f ${`name_var'imp1unl}
						}
						if ${`name_var'imp1unl} < 10 {
							global `name_var'imp1unl :  di %1.0f ${`name_var'imp1unl}
						}

			end //					

		*-------------------------------------------------------------------
		* 1.1h Getting statistics per lowdensity / high density
		*-------------------------------------------------------------------
		*To use after a "sum" command and a reg command, for instance, "sum `x' if t==0 & $sample==1 & dense_mkt==0". Gives stat and impact
					cap prog drop stat_ldense //clearing any program that might exist under that name. Always start with that line

				prog def stat_ldense
			args name_var 

						global `name_var'm0pu :  di %4.3f `r(mean)'
						global `name_var's0pu:  di %4.3f `r(sd)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1pu :  di %4.2f _b[t] / `sd'
							global `name_var'imp1pu =   _b[t] /`mean'*100
						if ${`name_var'imp1pu} >= 10 {
							global `name_var'imp1pu :  di %2.0f ${`name_var'imp1pu}
						}
						if ${`name_var'imp1pu} < 10 {
							global `name_var'imp1pu :  di %1.0f ${`name_var'imp1pu}
						}

			end //
		
			cap prog drop stat_hdense //clearing any program that might exist under that name. Always start with that line

				prog def stat_hdense
			args name_var 

						global `name_var'm0pr :  di %4.3f `r(mean)'
						local mean 	= `r(mean)'
						local sd 	= `r(sd)'
					
						global `name_var's1pr :  di %4.2f (_b[t] + _b[dense_mkt_t]) / `sd'
							global `name_var'imp1pr =   (_b[t] + _b[dense_mkt_t]) /`mean'*100
						if ${`name_var'imp1pr} >= 10 {
							global `name_var'imp1pr :  di %2.0f ${`name_var'imp1pr}
						}
						if ${`name_var'imp1pr} < 10 {
							global `name_var'imp1pr :  di %1.0f ${`name_var'imp1pr}
						}

			end //			

			cap prog drop stat_general //clearing any program that might exist under that name. Always start with that line

				prog def stat_general
			args name_var name_test
			
						global `name_var'm0 :  di %4.3f `r(mean)'
						
						* Control SD
						global `name_var's0 :  di %4.3f `r(sd)'									

						* Observations
						global `name_var'n = e(N)									
											
						* R-squared
						global `name_var'r :  di %4.3f e(r2)	
						
						*Test of equality
					cap	test `name_test'
						global `name_var'_test :  di %4.3f r(p)	

			end //
			
			
			cap prog drop stat_estim //clearing any program that might exist under that name. Always start with that line

				prog def stat_estim
			args name_var var
			
							* Coefficient
							global `name_var' :  di %4.3f _b[`var']
							
							* Standard error
							global `name_var'sd :  di %4.3f _se[`var']
							
							* P-value
							global `name_var'p: di %4.3f (2 * ttail(e(df_r), abs(_b[`var']/_se[`var'])))	
			end //
