/*******************************************************************************	

Project:  		KePSIE - Kenya

Written by:  	Thomas Escande (tescande@worldbank.org)

Revision: 		

********************************************************************************			

THIS DO FILE: 	 Explore the distribution of JHIC score

*******************************************************************************/

********************************************************************************
	** Part 0: Create globals for directories and files 
********************************************************************************
	clear all
	set more off
	set maxvar 20000
	pause on
	
	*Inputs
	global 	inputdata	 	"${dt_final}/data_for_analysis.dta" 
	
	*Output
	global  graph_location 	 "${out_appendix}"
	
********************************************************************************
	** Part 1: Graph
********************************************************************************
use "${inputdata}", clear 

local cutoff1 = 40
local cutoff2 = 60
local cutoff3 = 75


* McCary test
*For treatment 
set scheme cleanplots
preserve
keep if t == 1
DCdensity jhic_all  , breakpoint(40) generate(Xj Yj r0 fhat se_fhat) // graphtitle("Treatment Facilities") 
 graph export "${graph_location}/figure_A7a.png"	,replace	
restore

*For control
preserve
keep if t == 0
DCdensity jhic_all  , breakpoint(40) generate(Xj Yj r0 fhat se_fhat)   // graphtitle("Control Facilities") 
 graph export "${graph_location}/figure_A7b.png"	,replace
restore 
 
/*Both 
graph combine ///
	 "${graph_location}/supplemental/figure_A7a.png" ///
	 "${graph_location}/supplemental/figure_A7b.png" ///
	,  xsize(10) graphregion(color(white))
	
	graph export  "${graph_location}/figure_A7.png", replace 
	*/
