/*******************************************************************************	

Project:  		KePSIE - Kenya


Written by:  	Thomas Escande (tescande@worldbank.org)

Revision: 		

********************************************************************************			

THIS DO FILE: 	 Generating graphs for the JHIC score density for private and public facilities 

*******************************************************************************/
********************************************************************************
	** Part 0: Create globals for directories and files 
********************************************************************************
clear all

* Input 
glo inputdata 			"${dt_final}/data_for_analysis.dta" 

use "${inputdata}", clear
lab var jhic_all "JHIC Score"

preserve
keep if private == 1 
tw (histogram jhic_all if t == 0, percent color(gs11) width(2) start(10)) ///
   (histogram jhic_all if t == 1 ,percent color(none) lwidth(medium) lcolor(navy) width(2) start(10)), ///
    legend(off) title(Private Facilities) scheme(cleanplots) name(private) xtitle("")
restore	

preserve
keep if private == 0 
tw (histogram jhic_all if t == 0, percent color(gs11) width(2) start(10)) ///
   (histogram jhic_all if t == 1 ,percent color(none) lwidth(medium) lcolor(navy) width(2) start(10)), ///
    legend(order(1 "Control" 2 "Treatment") pos(6) row(1)) scheme(cleanplots) title("Public Facilities") name(public)
restore	

graph combine private public, row(2) xsize(3) graphregion(color(white))
	graph export  	"${out_appendix}/figure_A8.png", replace
