texdoc init "${table_name}", replace

tex \begin{tabular}{@{\extracolsep{3pt}}p{5.5cm}ccccc}
tex \\[-1.8ex]\hline \hline 
tex   & \multicolumn{1}{p{1.6cm}}{\centering $C_1} 
tex   & \multicolumn{1}{p{1.6cm}}{\centering $C_2} 
tex   & \multicolumn{1}{p{1.5cm}}{\centering $C_3} 
tex   & \multicolumn{1}{p{1.4cm}}{\centering $C_4} 
tex   & \multicolumn{1}{p{1.4cm}}{\centering $C_5} 
tex   \\[-.8ex]  
tex   & (1) & (2) & (3) & (4) & (5) \\ \hline 

tex \textbf{Panel A: }\textit{$PanelA} &  & &  \\
	tex $t  
	foreach var in $main_outcome {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'1} \\[-1.8ex] (${`var'1sd)}) \\[-1.8ex]  ${`var'_q2_1} \end{tabular}	    
	}
tex  \\

	foreach stat in N_ R_ {
tex ${`stat'text}
		foreach var in $main_outcome {
tex	    & ${`stat'`var'}
		}
tex		\\[-1.8ex]
	}

tex Control Mean 
	foreach var in $main_outcome {
tex	    & ${`var'm0}
		}
tex		\\[-1.8ex]

tex Impact: \{\%; SD\} 
	foreach var in $main_outcome {
tex	    & \{${`var'imp1}\%; ${`var's1}\}
		}

tex \\ 


foreach panel in B C {
tex \multicolumn{4}{@{}l}{\textbf{Panel `panel': }\textit{${Panel`panel'}}} &   \\    


foreach interac in t inter inter_t {
    local interac2  _`interac'
	local num = 3
    if "`interac'" == "t" {
	  local interac2 ""  
	  local num = 1
	}
	tex ${`interac'_`panel'} 
	foreach var in $main_outcome {
	    if "`interac'" == "inter" {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'_`panel'`interac2'`num'} \\[-1.8ex] (${`var'_`panel'`interac2'`num'sd)}) \\[-1.8ex] [${`var'_`panel'`interac2'`num'p}] \end{tabular}			    
		}
		
		else if "`interac'" == "t"  {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'_`panel'`interac2'`num'} \\[-1.8ex] (${`var'_`panel'`interac2'`num'sd)}) \\[-1.8ex] ${`var'_q2`panel'_2} \end{tabular}			    
		}
		
		else if  "`interac'" == "inter_t" {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'_`panel'`interac2'`num'} \\[-1.8ex] (${`var'_`panel'`interac2'`num'sd)}) \\[-1.8ex] ${`var'_q2`panel'_3} \end{tabular}			    
		}   
	}
tex  \\
}

	foreach stat in N_ R_ {
tex ${`stat'text}
		foreach var in $main_outcome {
tex	    & ${`stat'`var'_`panel'}
		}
tex		\\[-1.8ex]
	}

foreach type in pu pr {	
	if "`panel'" == "C" & "`type'" == "pu" {
		local type lic
	}	
	if "`panel'" == "C" & "`type'" == "pr" {
		local type unl
	}
tex Control Mean ${`panel'_`type'_text}
	foreach var in $main_outcome {
tex	    & ${`var'_`panel'm0`type'}
		}
tex		\\[-1.8ex]
}

foreach type in pu pr {
	if "`panel'" == "C" & "`type'" == "pu" {
		local type lic
	}	
	if "`panel'" == "C" & "`type'" == "pr" {
		local type unl
	}
tex Impact ${`panel'_`type'_text}: \{\%; SD\} 
	foreach var in $main_outcome {
tex	    & \{${`var'_`panel'imp1`type'}\%; ${`var'_`panel's1`type'}\}
		}
tex \\[-1.8ex]  
}

tex Test ${test_`panel'} (p-value)
	foreach var in $main_outcome {
tex	    & ${`var'_`panel'_intertest}
		}

tex \\
}


tex \\[-3.8ex] \hline \hline 
tex \end{tabular}

texdoc close

********************************End of Do File************************************
