/*******************************************************************************	
Project:  	KePSIE
*******************************************************************************/
********************************************************************************
** Create globals for directories and files 
********************************************************************************
clear all
set more off
	
* Input 
glo inputdata 					"${dt_final}/data_for_analysis.dta" 
glo inputdata_oop_p				"${dt_final}/oop_p.dta"
glo PE_wealth_index_bl    		"${dt_bl_const}/wealth_index_bl.dta" 
glo PE_clean_pii_bl       		"${dt_bl_clean}/pe_bl.dta"

* Output 
loc out 						table_2
glo tex_`out'					"${do_main}/tex/tex_`out'.do"
glo tex_`out'_out 				"${out_main}/`out'"	

* Programs
glo stats						"${program}/stats.do"
do "${stats}"	

********************************************************************************
** Table 1: Summary statistics at baseline
********************************************************************************
glo control_hfs 	level_3 level_4_5 	 
glo strata 			i.strata_expanded 
glo	sample 			s2


	 * Controls
*All
global  hd_controls_varlist_0_bl_2 	unlicensed_s0_all i.strata_expanded level_2_bl level_3_bl level_4_5_bl /// 
									private ///
									county startyear_group daysopen_bl  mfl_bl ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m ///
									dhs_wealth_kepsie educ_bl health_status_bl distance_bl
		 
*Public	 
global  hd_controls_varlist_1_bl_2 	unlicensed_s0_all i.strata_expanded level_2_bl level_3_bl level_4_5_bl ///
									county startyear_group daysopen_bl mfl_bl  ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m 	///
									dhs_wealth_kepsie educ_bl health_status_bl distance_bl
								 
*Private								 
global  hd_controls_varlist_2_bl_2 	unlicensed_s0_all i.strata_expanded level_2_bl level_3_bl level_4_5_bl ///									
									county startyear_group daysopen_bl mfl_bl private_type_bl ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m 	///
									dhs_wealth_kepsie educ_bl health_status_bl distance_bl
									
*All
global  hd_controls_varlist_0_bl 	unlicensed_s0_all i.strata_expanded level_2_bl level_3_bl level_4_5_bl /// 
									private ///
									county startyear_group daysopen_bl  mfl_bl ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m 
		 
*Public	 
global  hd_controls_varlist_1_bl 	unlicensed_s0_all i.strata_expanded level_2_bl level_3_bl level_4_5_bl ///
									county startyear_group daysopen_bl mfl_bl  ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m 	
								 
*Private								 
global  hd_controls_varlist_2_bl 	unlicensed_s0_all i.strata_expanded level_2_bl level_3_bl level_4_5_bl ///									
									county startyear_group daysopen_bl mfl_bl private_type_bl ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m 			
									
*All no factor
global  controls_varlist_include 	unlicensed_s0_all strata_expanded level_2_bl level_3_bl level_4_5_bl /// 
									private ///
									county startyear_group daysopen_bl  mfl_bl ///
									lab_bl pharm_bl consult_rooms_bl ngofbo_bl nhif_outp_bl nhif_outp_mo_bl nhif_plus_bl  /// 
									staff_total_bl qual_bl qual_per_bl  ///
									marketsize_r0  maintown_km_bl maintown_km_group_bl maintown_m_bl market_e_km_group ///
									market_e_km  ///
									public_tot_s0 public_2plus_s0 allprivate_s0 allpublic_s0 singleton_s0 jhic_all_bl_m 										
								 
*********************************************************************************		

	*Main var: Gradient with JHIC score at Baseline
	local x jhic_all_bl	

set seed 1234
******************************************************************************** 
** Private
********************************************************************************/ 

********************************Change when needed ***********************************************************
local type = "priv"
**************************************************************************************************************

	if "`type'" == "all" {
		local priv = 0
		local sample ""
		local control "private"
		local if ""
		local title_main "All Facilities"
	}	
	if "`type'" == "pub" {
		local priv = 1
		local sample "& private == 0"
		local control ""
		local if "if private == 0"
	}
	if "`type'" == "priv" {
		local priv = 2
		local sample "& private == 1"
		local control ""
		local if "if private == 1"	
		local title_main "Private Facilities"
	}
	

	
******************************************* using pdslasso to select control
foreach y in oop_all_bl oop_all_bl_2 mkt_share_bl inactive  {
	
	local y_var `y'
	
	*For exit (inactive), do only on the control group as we are using the endline variable 
		if "`y'" == "oop_all_bl" {
			local control_only ""
			local add_var_control "outp_as_jan_bl mkt_share_bl"	
			local add ""	
local partial_var_main  "unlicensed_s0_all level_2_bl level_3_bl level_4_5_bl i.strata_expanded marketsize_r0 startyear_group" /*"*/			
		}
		if "`y'" == "oop_all_bl_2" {
			local y_var oop_all_bl
			local control_only ""
			local add_var_control "outp_as_jan_bl mkt_share_bl"	
			local partial_var_main  "unlicensed_s0_all  dhs_wealth_kepsie  educ_bl health_status_bl distance_bl level_2_bl level_3_bl level_4_5_bl  i.strata_expanded marketsize_r0 startyear_group" /*Adding patient level characteristics*/		
			local add "_2"
		}		
		if "`y'" == "mkt_share_bl" {
			local control_only ""
			local add_var_control ""
			local add ""
local partial_var_main  "unlicensed_s0_all level_2_bl level_3_bl level_4_5_bl i.strata_expanded marketsize_r0 startyear_group" /*"*/			
		}
		if "`y'" == "inactive" {
			local control_only "& t == 0"	
			local add_var_control "outp_as_jan_bl mkt_share_bl"	
			local add ""
local partial_var_main  "unlicensed_s0_all level_2_bl level_3_bl level_4_5_bl i.strata_expanded marketsize_r0 startyear_group" /*"*/			
		}		

		
*For OOP do at the patient level, for the others, do it at the facility level 		
		if "`y'" == "oop_all_bl" | "`y'" == "oop_all_bl_2"  {
	use "${inputdata_oop_p}", clear
	
	
*Merging to add Patient data 
drop if mi(key)
merge 1:1 key using "${PE_clean_pii_bl}", keep(3) keepusing(educ_bl health_status_bl distance_bl) nogen	
merge 1:1 key using "${PE_wealth_index_bl}", keep(3) keepusing(dhs_wealth_kepsie)	nogen
merge m:1 hfid using "${inputdata}" , keep(3) keepusing(${controls_varlist_include} unlicensed_s0_all strata_expanded marketsize_r0 startyear_group ) nogen 			
		}

		if "`y'" == "mkt_share_bl" | "`y'" == "inactive"  {
	use "${inputdata}", clear		
		}
		
	
	gen jhic_all_bl_unli = jhic_all_bl * unlicensed_s0_all
	
	
	* Generate market share 
	gen mkt_share_bl = outp_as_jan_bl/ outp_as_jan_bl_m * 100		
		
		
*Run PDS lasso 		
pdslasso `y_var' `x'  ///
		(${hd_controls_varlist_`priv'_bl`add'} `add_var_control') `if' `control_only' ///
		, ///
		partial(`partial_var_main') cluster(market_all_expanded) rlasso

glo N_var`y'_pr = e(xselected_ct)		
		
* `e(xselected)' are the controls selected by the PDSlasso		
	reg 	`y_var' `x'  `partial_var_main' `e(xselected)'	 if e(sample) == 1 `control_only',  vce(cluster market_all_expanded)	
	
glo grad_R_`y'_pr    : di %4.2f `e(r2_a)'

	
*Saving for later the different coefficients
local c  : di %4.3f  _b[`x']
local p  = r(table)[4,1]	
glo grad_`y'_c_pr  = "`c'"
if `p' <= 0.1 {
glo grad_`y'_c_pr  = "${grad_`y'_c_pr}"	+ "*"
	if `p' <= 0.05 {
		glo grad_`y'_c_pr  = "${grad_`y'_c_pr}"	+ "*"
		if `p' <= 0.01 {
			glo grad_`y'_c_pr  = "${grad_`y'_c_pr}"	+ "*"
		}
	}
}

*Saving for later the different coefficients
	local var_count = 2
	local control_to_save unlicensed_s0_all
			if "`y'" == "oop_all_bl_2" {
					local control_to_save unlicensed_s0_all dhs_wealth_kepsie educ_bl health_status_bl distance_bl
			}
foreach var in `control_to_save' {

local c`var_count'  : di %4.3f  _b["`var'"]
local p`var_count'  = r(table)[4,`var_count']	
glo grad_`y'_c`var_count'_pr  = "`c`var_count''"
if `p`var_count'' <= 0.1 {
glo grad_`y'_c`var_count'_pr  = "${grad_`y'_c`var_count'_pr}"	+ "*"
	if `p`var_count'' <= 0.05 {
		glo grad_`y'_c`var_count'_pr  = "${grad_`y'_c`var_count'_pr}"	+ "*"
		if `p`var_count'' <= 0.01 {
			glo grad_`y'_c`var_count'_pr  = "${grad_`y'_c`var_count'_pr}"	+ "*"
		}
	}
}	


local se`var_count' : di %4.3f _se["`var'"]
glo grad_`y'_se`var_count'_pr = "(" + "`se`var_count''" + ")"

local var_count = `var_count' + 1
}

local se : di %4.3f _se[`x']
glo grad_`y'_se_pr = "(" + "`se'" + ")"


glo grad_N_`y'_pr = e(N)

	*JHIC score
	sum jhic_all_bl if $sample == 1 `sample' & e(sample) == 1
	local jhic_bl_mean : di %4.2f r(mean)
	local jhic_bl_se   : di %4.2f r(sd)	
	glo jhic_m_`y'_pr    `jhic_bl_mean'
	glo jhic_se_`y'_pr   `jhic_bl_se'

	
	* Dependent var mean
	sum `y_var' if $sample == 1 `sample' & e(sample) == 1
	glo `y'_m_pr : di %4.2f `r(mean)'


}


******************************************************************************** 
** Public
********************************************************************************/

********************************Change when needed ***********************************************************
local type = "pub"
**************************************************************************************************************

	if "`type'" == "all" {
		local priv = 0
		local sample ""
		local control "private"
		local if ""
		local title_main "All Facilities"
	}	
	if "`type'" == "pub" {
		local priv = 1
		local sample "& private == 0"
		local control ""
		local if "if private == 0"
	}
	if "`type'" == "priv" {
		local priv = 2
		local sample "& private == 1"
		local control ""
		local if "if private == 1"	
		local title_main "Private Facilities"
	}

******************************************* using pdslasso to select control
foreach y in oop_all_bl  mkt_share_bl inactive  {
	
	*For exit (inactive), do only on the control group as we are using the endline variable 
		if "`y'" == "oop_all_bl" {
			local control_only ""
			local add_var_control "outp_as_jan_bl mkt_share_bl"	
		}
		if "`y'" == "mkt_share_bl" {
			local control_only ""
			local add_var_control ""
		}
		if "`y'" == "inactive" {
			local control_only "& t == 0"	
			local add_var_control "outp_as_jan_bl mkt_share_bl"	
		}		
		
********************************Change when needed ***********************************************************
local partial_var_main  "level_2_bl level_3_bl level_4_5_bl i.strata_expanded marketsize_r0 startyear_group" /*"*/
**************************************************************************************************************		

*For OOP do at the patient level, for the others, do it at the facility level 		
		if "`y'" == "oop_all_bl"  {
	use "${inputdata_oop_p}", clear
	
	
*Merging to add Patient data 
drop if mi(key)
merge 1:1 key using "${PE_clean_pii_bl}", keep(3) keepusing(educ_bl health_status_bl distance_bl) nogen	
merge m:1 hfid using "${inputdata}" , keep(3) keepusing(${controls_varlist_include} unlicensed_s0_all strata_expanded marketsize_r0 startyear_group ) nogen 			
		}

		if "`y'" == "mkt_share_bl" | "`y'" == "inactive"  {
	use "${inputdata}", clear		
		}
		
	
	gen jhic_all_bl_unli = jhic_all_bl * unlicensed_s0_all
	
	
	* Generate market share 
	gen mkt_share_bl = outp_as_jan_bl/ outp_as_jan_bl_m * 100

		
pdslasso `y' `x'  ///
		(${hd_controls_varlist_`priv'_bl} `add_var_control') `if' `control_only' ///
		, ///
		partial(`partial_var_main') cluster(market_all_expanded) rlasso

glo N_var`y'_pu = e(xselected_ct)		
		
* `e(xselected)' are the controls selected by the PDSlasso		
	reg 	`y' `x'  `partial_var_main' `e(xselected)'	 if e(sample) == 1 `control_only',  vce(cluster market_all_expanded)	
	
glo grad_R_`y'_pu    : di %4.2f `e(r2_a)'

	
*Saving for later the different coefficients
local c  : di %4.3f  _b[`x']
local p  = r(table)[4,1]	
glo grad_`y'_c_pu  = "`c'"
if `p' <= 0.1 {
glo grad_`y'_c_pu  = "${grad_`y'_c_pu}"	+ "*"
	if `p' <= 0.05 {
		glo grad_`y'_c_pu  = "${grad_`y'_c_pu}"	+ "*"
		if `p' <= 0.01 {
			glo grad_`y'_c_pu  = "${grad_`y'_c_pu}"	+ "*"
		}
	}
}



local se : di %4.3f _se[`x']
glo grad_`y'_se_pu = "(" + "`se'" + ")"


glo grad_N_`y'_pu = e(N)

	*JHIC score
	sum jhic_all_bl if $sample == 1 `sample' & e(sample) == 1
	local jhic_bl_mean : di %4.2f r(mean)
	local jhic_bl_se   : di %4.2f r(sd)	
	glo jhic_m_`y'_pu    `jhic_bl_mean'
	glo jhic_se_`y'_pu   `jhic_bl_se'

	
	* Dependent var mean
	sum `y' if $sample == 1 `sample' & e(sample) == 1
	glo `y'_m_pu : di %4.2f `r(mean)'


}




glo SC_1	"Private"
glo SC_2	"Public"

glo C_1		"OOP (USD PPP) at Baseline"
glo C_2		"Market Share at Baseline (x100)"
glo C_3		"Exit by Endline (Control Facilities)"
glo C_4		"OOP (USD PPP) at Baseline"
glo C_5		"Market Share at Baseline (x100)"

glo R_1		"JHIC Score at Baseline"
glo R_2		"Unlicensed at Baseline"
glo R_3		"Patient Wealth Index"
glo R_4		"Patient Years of Education"
glo R_5		"Patient Health Status (Bad or Very Bad)"
glo R_6		"Distance from Home (in Km)"

glo vars_pr oop_all_bl oop_all_bl_2 mkt_share_bl inactive
glo vars_pu oop_all_bl mkt_share_bl 
	
* Table global
glo table_name "${tex_`out'_out}"

* Start the Latex document
texdoc do "${tex_`out'}"

				


				
				
				
				
				
				
				
