texdoc init "${table_name}", replace

tex \begin{tabular}{@{\extracolsep{3pt}}p{6cm}ccccccc}
tex \\[-1.8ex]\hline \hline 
tex   & \multicolumn{2}{c}{Unweighted} & \multicolumn{2}{c}{Weighted} & & \\
tex   \cline{2-3} \cline{4-5}
tex   & \multicolumn{1}{c}{$C_1} & \multicolumn{1}{c}{$C_2}  & \multicolumn{1}{c}{$C_1}  & \multicolumn{1}{c}{$C_2}  & \multicolumn{1}{c}{$C_3}  & \multicolumn{1}{c}{$C_4}
tex   \\[-1.8ex] 
tex   & \multicolumn{1}{c}{$C_1_s} & \multicolumn{1}{c}{$C_2_s}  &  \multicolumn{1}{c}{$C_1_s} & \multicolumn{1}{c}{$C_2_s}  & \multicolumn{1}{c}{$C_3_s}  & \multicolumn{1}{c}{$C_4_s} 
tex   \\[-1.8ex]  
tex   & (1) & (2) & (3)  & (4) & (5) & (6) \\ \hline 

tex \textbf{Panel A: }\textit{$PanelA} &  &  &  &  \\
	tex $t  
	foreach var in $outcome_toweight $outcome_weighted outp_as_jan {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'1} \\[-1.8ex] (${`var'1sd)}) \\[-1.8ex] ${`var'_q2} \end{tabular}	    
	}
	foreach var in new_end {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'1} \\[-1.8ex] (${`var'1sd)}) \\[-1.8ex] [${`var'1p}] \end{tabular}	    
	}	
tex  \\

	foreach stat in N_ R_ {
tex ${`stat'text}
		foreach var in $main_outcomes {
tex	    & ${`stat'`var'}
		}
tex		\\[-1.8ex]
	}

tex Control Mean 
	foreach var in $main_outcomes {
tex	    & ${`var'm0}
		}
tex		\\[-1.8ex]

tex Impact: \{\%; SD\} 
	foreach var in $main_outcomes {
tex	    & \{${`var'imp1}\%; ${`var's1}\}
		}

tex \\ 


foreach panel in B C {
tex \multicolumn{4}{@{}l}{\textbf{Panel `panel': }\textit{${Panel`panel'}}}   & & & &   \\    


foreach interac in t inter inter_t {
    local interac2  _`interac'
	local num = 3
    if "`interac'" == "t" {
	  local interac2 ""  
	  local num = 1
	}
	tex ${`interac'_`panel'} 
	foreach var in $main_outcomes {
tex & \begin{tabular}[t]{@{}c@{}} ${`var'_`panel'`interac2'`num'} \\[-1.8ex] (${`var'_`panel'`interac2'`num'sd)}) \\[-1.8ex] [${`var'_`panel'`interac2'`num'p}] \end{tabular}	    
	}
tex  \\
}

	foreach stat in N_ R_ {
tex ${`stat'text}
		foreach var in $main_outcomes {
tex	    & ${`stat'`var'_`panel'}
		}
tex		\\[-1.8ex]
	}

foreach type in pu pr {	
	if "`panel'" == "C" & "`type'" == "pu" {
		local type lic
	}	
	if "`panel'" == "C" & "`type'" == "pr" {
		local type unl
	}
tex Control Mean ${`panel'_`type'_text}
	foreach var in $main_outcomes {
tex	    & ${`var'_`panel'm0`type'}
		}
tex		\\[-1.8ex]
}

foreach type in pu pr {
	if "`panel'" == "C" & "`type'" == "pu" {
		local type lic
	}	
	if "`panel'" == "C" & "`type'" == "pr" {
		local type unl
	}
tex Impact ${`panel'_`type'_text}: \{\%; SD\} 
	foreach var in $main_outcomes {
tex	    & \{${`var'_`panel'imp1`type'}\%; ${`var'_`panel's1`type'}\}
		}
tex \\[-1.8ex]  
}

tex Test ${test_`panel'} (p-value)
	foreach var in $main_outcomes {
tex	    & ${`var'_`panel'_intertest}
		}

tex \\
}

tex \\[-1.8ex] \hline \hline 
tex \end{tabular}

texdoc close

********************************End of Do File************************************
