*Mediation construction of dataset
*Setting up globals and all
clear all
set more off

global inputdata	 	"${dt_final}/data_for_analysis.dta"

global mediat			"${dt_end_fin}/mediation.dta"

*Preparing dataset to be run
use "${inputdata}", clear 

replace close_enforce = 0 if t == 0 //currently missing for control variables  
replace close_enforce = 0 if inspections == 0 //Also replacing by 0 for facilites in the treatment group that were not inspected because opened after randomization

*Replace private type with others as otherwise if it was NGO or FBO we would have the info 
replace private_type = 3 if mi(private_type)
replace private_type = 0  if private == 0 // New categorie for public facilities counted as 0 

*unlicense variable dummies in categorical 0 = missing, 1 = license, 2 = expired , 3 = no license
gen unlicensed          = (unlicensed_noexp_s0 == 1)
gen unlicensed_expired  = (unlicensed_s0_all == 1 & unlicensed_noexp_s0==0)
gen unlicensed_missing  = (unlicensed_s0_all == .)
gen unlicensed_all_rand = (unlicensed_s0_all == 1)
gen unlicensed_all_end  = (formality_all == 0)

gen unlicensed_all_end_missing  = (formality_all == .)

lab var unlicensed 			"no license at randomization"
lab var unlicensed_expired  "expired license at randomization"

lab var unlicensed_all_rand "unlicensed (with expired license) at randomization"
lab var unlicensed_all_end  "unlicensed at endline"
 

* create market-level values and interactions with treatment when it matters (closures only happened in T so no need for interaction)

gen inactive_t_m= inactive_m*t
*bys market_all_expanded: egen close_enforce_m=sum(close_enforce)

foreach x in close_enforce unlicensed_all_rand unlicensed_all_end unlicensed_all_end_missing {
bys market_all_expanded: egen `x'_m=sum(`x')
}

save "${mediat}", replace
